<!DOCTYPE html>
<html lang="en">
    <head>
        <title>CRUD Read Load all users</title>
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
        <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
        <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
        <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
        <!-- Data Table-->
        <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
        <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
        <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
      </head>
<body>
    <!-- vùng header -->
    <div class="container">
        <div class="text-center">
            <h2>Danh sách người dùng đăng ký</h2>
        </div>
        <div class="form-group">
            <button class="btn btn-success" id="btn-thêm-user"><i class="fa fa-plus"></i>&nbsp; Thêm user</button>
        </div>
    </div>
    <!-- vùng data table -->
    <div class="container">
        <table class="table table-bordered table-striped table-hover" id="user-table">
            <thead>
              <tr>
                <th>Id</th>
                <th>First Name</th>
                <th>Last Name</th>
                <th>Country</th>
                <th>Subject</th>
                <th>Customer Type</th>
                <th>Register Status</th>
                <th>Action</th>
              </tr>
            </thead>
          </table>
    </div>
    <!-- vùng modal -->
    <!-- Create user modal -->
    <div>
    <div id="create-user-modal" class="modal fade" tabindex="-1">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">Create new User</h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <form>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="inp-create-firstname">First Name</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="inp-first-name" name="firstname" placeholder="..."
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="inp-create-lastname">Last Name</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="inp-last-name" name="lastname" placeholder="..."
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label>Country</label>
                </div>
                <div class="col-sm-8">
                  <select name="country" id="select-country" class="form-control">
                    <option value="0">...</option>
                    <option value="VN">Việt Nam</option>
                    <option value="USA">USA</option>
                    <option value="CAN">Canada</option>
                    <option value="AUS">ÚC</option>
                  </select>
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label>Customer Type</label>
                </div>
                <div class="col-sm-8">
                    <select name="country" id="select-customertype" class="form-control">
                        <option value="0">...</option>
                        <option value="Standa">Standa</option>
                        <option value="Standard">Standard</option>
                      </select>
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="inp-subject">Subject</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="inp-subject" name="subject" placeholder="..."
                    class="form-control">
                </div>
              </div>
            </form>
          </div>
          <div class="modal-footer">
            <button class="btn btn-secondary" id="btn-create-cancel" data-dismiss="modal">Cancel</button>
            <button class="btn btn-primary" id="btn-create-user">Insert User</button>
          </div>
        </div>
      </div>
    </div>
  </div>

  <!-- Update user modal -->
  <div>
    <div id="update-user-modal" class="modal fade" tabindex="-1">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">Chi tiết User</h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <form>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-update-user-code">First Name</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-update-firstname" name="firstname" placeholder="..."
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-update-user-code">Last Name</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-update-lastname" name="lastname" placeholder="..."
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-update-user-code">Subject</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-update-subject" name="subject" placeholder="..."
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-update-user-code">Country</label>
                </div>
                <div class="col-sm-8">
                  <select name="country" id="select-country" class="form-control">
                    <option value="VN">Việt Nam</option>
                    <option value="USA">USA</option>
                    <option value="AUS">ÚC</option>
                    <option value="CAN">Canada</option>
                  </select>
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-update-user-code">Customer Type</label>
                </div>
                <div class="col-sm-8">
                  <select name="country" id="select-customertype" class="form-control">
                    <option value="Standard">Standard</option>
                    <option value="Gold">Gold</option>
                    <option value="Premium">Premium</option>
                  </select>
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-update-user-code">Register Status</label>
                </div>
                <div class="col-sm-8">
                  <select name="registerstatus" id="select-register-status" class="form-control">
                    <option value="New">New</option>
                    <option value="Accepted">Accepted</option>
                    <option value="Denied">Denied</option>
                  </select>
                </div>
              </div>
            </form>
          </div>
          <div class="modal-footer">
            <button class="btn btn-secondary" id="btn-update-cancel" data-dismiss="modal">Hủy bỏ</button>
            <button class="btn btn-primary" id="btn-update-user">Update User</button>
          </div>
        </div>
      </div>
    </div>
  </div>

  <!-- Delete confirm modal -->
  <div>
    <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">User Delete Confirmation</h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <label>Bạn có chắc chắn muốn xóa User này không?</label>
          </div>
          <div class="modal-footer">
            <button class="btn btn-danger" id="btn-confirm-delete-user">Confirm</button>
            <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
          </div>
        </div>
      </div>
    </div>
  </div>
</body>

<script>
    "use strict";
    //REGION 1
    const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
    // biến toàn cục để lưu trữ id user đang được delete và update mặc định bằng 0
    var gUserId = 0;
    // biến mảng hằng số chứa danh sách các tên thuộc tính
    const gUSER_COLS = ["id", "firstname", "lastname", "country", "subject", "customerType", "registerStatus", "action"]
    //biến mảng toàn cục đinh nghĩa chỉ số các cột tương ướng
    const gUSER_ID_COL = 0;
    const gFIRST_NAME_COL = 1;
    const gLAST_NAME_COL = 2;
    const gCOUNTRY_COL = 3;
    const gSUBJECT_COL = 4;
    const gCUSTOMER_TYPE_COL = 5;
    const gREGISTER_STATUS_COL = 6;
    const gACTION_COL = 7;
    //khai báo dataTable và mapping column
    var gUserTable = $("#user-table").DataTable({
        columns: [
            {data: gUSER_COLS[gUSER_ID_COL]},
            {data: gUSER_COLS[gFIRST_NAME_COL]},
            {data: gUSER_COLS[gLAST_NAME_COL]},
            {data: gUSER_COLS[gCOUNTRY_COL]},
            {data: gUSER_COLS[gSUBJECT_COL]},
            {data: gUSER_COLS[gCUSTOMER_TYPE_COL]},
            {data: gUSER_COLS[gREGISTER_STATUS_COL]},
            {data: gUSER_COLS[gACTION_COL]},
        ],
        columnDefs: [
            { //định nghĩa lại col action
                targets: gACTION_COL,
                defaultContent: `
                <img class="edit-user" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
                <img class="delete-user" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
                `
            }
        ]
    })
    //REGION 2
    $(document).ready(function(){
        onPageLoading()
        //sự kiện thêm mới user
        $("#btn-thêm-user").on("click", function(){
            onBtnAddNewUserClick();
        })
        //gán sự kiện nút edit được ấn
        $("#user-table").on("click", ".edit-user", function(){
            onBtnEditClick(this);
        });
        //gán sự kiện nut delete được ấn
        $("#user-table").on("click", ".delete-user", function(){
            onBtnDeleteClick(this);
        });
        //gán sự cho nút Create User (trên modal)
        $("#btn-create-user").on("click", function(){
            onBtnCreateUserClick();
        })
        //gán sự kiện cho nút update user trên form (trên modal)
        $("#btn-update-user").on("click", function(){
          onBtnUpdateUserClick();
        });
        // gán sự kiện cho nút confirm delete (trên modal)
        $("#btn-confirm-delete-user").on("click", function(){
          onBtnConfirmDeleteUserClick()
        })
    });
    //REGION 3
    function onPageLoading(){
        getAllUsers();
    }
    //hàm thự hiện sự kiện nút confirm delete được click
    function onBtnConfirmDeleteUserClick(){
      console.log("nút được ấn");
      //b1 thu thập dữ liệu
      //b2 kiểm tra dữ liệu
      //b3 gọi api
      $.ajax({
        url: gBASE_URL + gUserId,
        type: "DELETE",
        success: function(){
          handleDeleteUserSuccess();
        },
        error: function(err){
          console.log(err.status)
        }
      })
      //b4 xủ lý hiển thị
    }
    //hàm thự hiện sự kiện nút sửa được click
    function onBtnEditClick(paramEvent){
        console.log("nút edit được ấn");
        //lưu thông tin UserId đang được edit vào biến toàn cục
        gUserId = getUserIdFormBtn(paramEvent);
        console.log("id của user tương ứng là: " + gUserId);
        //hàm load dữ liệu lên form
        getUserById(gUserId);
    }
    //hàm thực hiện sự kiện nút delete được click
    function onBtnDeleteClick(paramEvent){
        console.log("nut delete được ấn");
        gUserId = getUserIdFormBtn(paramEvent);
        console.log("id của user tương ứng là: " + gUserId);
        //hiển thị modal
        $("#delete-confirm-modal").modal("show");

    }
    //hàm thực hiện sự kiện nút thêm mới user được ấn
    function onBtnAddNewUserClick(){
        $("#create-user-modal").modal("show");
    }
    //hàm thự hiện sự kiện nút insert User (trên modal) được ấn
    function onBtnCreateUserClick(){
        //khai báo đối tượng chứa user data
        var vCreateUser = {
            firstname: "",
            lastname: "",
            subject: "",
            country: "",
            customerType: "",
        }
        // b1 thu thập dữ liệu
        getInsertData(vCreateUser);
        // b2 kiểm tra dữ liệu
        var vValidate = validateUserData(vCreateUser);
        if(vValidate){
            //b3 gọi api
           $.ajax({
            url: gBASE_URL,
            type: "POST",
            contentType: "application/json;charset=UTF-8",
            data: JSON.stringify(vCreateUser),
            success: function(paramRes){
                console.log(paramRes);
                // b4 xử lý hiển thị
                handlerInsertUserSuccess();
            },
            error: function(ajaxContext){
                console.log(ajaxContext.status);
            }
           })
        }
    }
    //hàm thực hiện sự kiện nút update user trên form edit được click
    function onBtnUpdateUserClick(){
      //khai báo đối tượng chứa data
      var vUserUpdate = {
        firstname: "",
        lastname: "",
        subject: "",
        country: "",
        customerType: "",
      }
      //b1 thu thập dữ liệu
      getUpdateUserData(vUserUpdate)
      //b2 kiểm tra dữ liệu
      var vIsCheck = validateUpdateUser(vUserUpdate)
      if(vIsCheck){
        //b3 goi api
        $.ajax({
          url: gBASE_URL + gUserId,
          type: "PUT",
          contentType: "application/json;charset=UTF-8",
          data: JSON.stringify(vUserUpdate),
          success: function(res){
              console.log(res);
              //b4: xử lý hiển thị
              resertUpdateUserForm(res);
          },
          error: function(error){
            console.log(error.status);
          }
        });
      }
      
    }
    //REGION 4
    //hàm xử lý hiển thị khi user được xóa thành công
    function handleDeleteUserSuccess() {
      alert("Xóa user thành công!"); //thông báo xóa user thành công
      getAllUsers(); //load lại trang
      $("#delete-confirm-modal").modal("hide"); //ẩn modal
    }
    //hàm xử lý hiển thị khi update user thành công
    function resertUpdateUserForm(paramObj){
        alert("Thêm thông tin thành công"); //thông báo đã cập nhật thành công
        getAllUsers();  // load lại trang
        resertFormUpdateUser(); //xóa trắng form
        $("#update-user-modal").modal("hide");
    }
    //hàm xóa trắng form update user
    function resertFormUpdateUser(){
      $("#input-update-firstname").val("");
      $("#input-update-lastname").val("");
      $("#input-update-subject").val("");
      $("#select-country").val("VN");
      $("#select-customertype").val("Standard");
    }
    //hàm thu thập dữ liệu trên form update user
    function getUpdateUserData(paramUser){
      paramUser.firstname = $("#input-update-firstname").val().trim();
      paramUser.lastname = $("#input-update-lastname").val().trim()
      paramUser.subject = $("#input-update-subject").val().trim();
      paramUser.country = $("#select-country").val();
      paramUser.customerType = $("#select-customertype").val();
    }
    //hàm kiểm tra dữ liệu update user trên form
    function validateUpdateUser(paramUser){
      if(paramUser.firstname == ""){
        alert("Bạn chưa nhập first name");
        return false;
      };
      if(paramUser.lastname == ""){
        alert("Bạn chưa nhập last name");
        return false;
      };
      return true;
    }
    //hàm gọi api lấy user qua id
    function getUserById(paramUserId){
      $.ajax({
        url: gBASE_URL + paramUserId,
        type: "GET",
        dataType: "json",
        success: function(response){
          console.log(response)
          showDataToformUpdate(response);
        },
        error: function(xhr, status, error){
          console.log(error)
        }
      })
      //hiển thị modal lên
      $("#update-user-modal").modal("show");
    }
    //hàm hiển thị data user lên form (modal) cần update
    function showDataToformUpdate(paramRes){
      $("#input-update-firstname").val(paramRes.firstname);
      $("#input-update-lastname").val(paramRes.lastname);
      $("#input-update-subject").val(paramRes.subject);
      $("#select-country").val(paramRes.country);
      $("#select-customertype").val(paramRes.customerType);
    }
    // xử lý hiển thị khi thêm user thành công
    function handlerInsertUserSuccess(){
        alert("Thêm thông tin thành công");
        getAllUsers();
        resertCreateUserForm();
        $("#create-user-modal").modal("hide");
    }
    //hàm xóa trắng form create form
    function resertCreateUserForm(){
      $("#inp-first-name").val("");
      $("#inp-last-name").val("");
      $("#select-country").val("0");
      $("#select-customertype").val("0");
      $("#inp-subject").val("");
    }
    //hàm thu thập dữ liệu trên form modal thêm user
    function getInsertData(paramUser){
        paramUser.firstname = $("#inp-first-name").val().trim();
        paramUser.lastname = $("#inp-last-name").val().trim();
        paramUser.subject = $("#inp-subject").val().trim();
        paramUser.country = $("#select-country").val();
        paramUser.customerType = $("#select-customertype").val();
    }
    //hàm kiểm tra dữ liệu trên (modal) thêm mới user
    function validateUserData(paramUser){
        if(paramUser.firstname == ""){
            alert("Bạn chưa nhập first name !!");
            return false;
        }
        if(paramUser.lastname == ""){
            alert("Bạn chưa nhập last name");
            return false;
        }
        if(paramUser.country == 0){
            alert("Bạn chưa chon country");
            return false;
        }
        if(paramUser.customerType == 0){
            alert("Bạn chưa chọn Customer type");
            return false;
        }
        if(paramUser.subject == ""){
            alert("Bạn chưa nhập subject");
            return false;
        }
        return true;
    }

    //hàm gọi api lấy data tất cả user
    function getAllUsers(){
        $.ajax({
            url: "http://203.171.20.210:8080/crud-api/users/",
            type: "GET",
            success: function(response){
                console.log(response);
                loadDataToTable(response);
            },
            error: function(ajaxContext){
                console.log(ajaxContext.responseText);
            }
        })
    }

    //hàm load users to dataTable
    function loadDataToTable(paramUser){
        gUserTable.clear();
        gUserTable.rows.add(paramUser);
        gUserTable.draw();
    }

    //hàm dựa vào btn detail (edit or delete) xác định được id của user
    function getUserIdFormBtn(paramBtn){
        var vTableRow = $(paramBtn).parents("tr");
        var vUserRowData = gUserTable.row(vTableRow).data();
        return vUserRowData.id;
    }
</script>
</html>